//=============================================================================
//
// file :         GuntimingClass.h
//
// description :  Include for the GuntimingClass root class.
//                This class is represents the singleton class for
//                the Guntiming device class.
//                It contains all properties and methods which the 
//                Guntiming requires only once e.g. the commands.
//			
// project :      TANGO Device Server
//
// $Author: zambonl $
//
// $Revision: 1.1.1.1 $
//
// $Log: GuntimingClass.h,v $
// Revision 1.1.1.1  2014-12-11 14:05:08  zambonl
// Prima versione
//
// Revision 1.1.1.1  2014-11-11 10:00:36  zambonl
// Prima versione
//
// Revision 1.1.1.1  2013-08-06 08:24:53  zambonl
// Prima versione
//
//
// copyleft :     European Synchrotron Radiation Facility
//                BP 220, Grenoble 38043
//                FRANCE
//
//=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================

#ifndef _GUNTIMINGCLASS_H
#define _GUNTIMINGCLASS_H

#include <tango.h>
#include <Guntiming.h>


namespace Guntiming_ns
{
//=====================================
//	Define classes for attributes
//=====================================
class StateFlagsAttrib: public Tango::SpectrumAttr
{
public:
	StateFlagsAttrib():SpectrumAttr("StateFlags", Tango::DEV_BOOLEAN, Tango::READ, 6) {};
	~StateFlagsAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Guntiming *>(dev))->read_StateFlags(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Guntiming *>(dev))->is_StateFlags_allowed(ty);}
};

class FilCursetAttrib: public Tango::Attr
{
public:
	FilCursetAttrib():Attr("FilCurset", Tango::DEV_DOUBLE, Tango::READ) {};
	~FilCursetAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Guntiming *>(dev))->read_FilCurset(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Guntiming *>(dev))->is_FilCurset_allowed(ty);}
};

class FilVoltageAttrib: public Tango::Attr
{
public:
	FilVoltageAttrib():Attr("FilVoltage", Tango::DEV_DOUBLE, Tango::READ) {};
	~FilVoltageAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Guntiming *>(dev))->read_FilVoltage(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Guntiming *>(dev))->is_FilVoltage_allowed(ty);}
};

class PolVoltageAttrib: public Tango::Attr
{
public:
	PolVoltageAttrib():Attr("PolVoltage", Tango::DEV_DOUBLE, Tango::READ) {};
	~PolVoltageAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Guntiming *>(dev))->read_PolVoltage(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Guntiming *>(dev))->is_PolVoltage_allowed(ty);}
};

class TemperatureAttrib: public Tango::Attr
{
public:
	TemperatureAttrib():Attr("Temperature", Tango::DEV_DOUBLE, Tango::READ) {};
	~TemperatureAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Guntiming *>(dev))->read_Temperature(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Guntiming *>(dev))->is_Temperature_allowed(ty);}
};

class BunchLengthAttrib: public Tango::Attr
{
public:
	BunchLengthAttrib():Attr("BunchLength", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~BunchLengthAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Guntiming *>(dev))->read_BunchLength(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Guntiming *>(dev))->write_BunchLength(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Guntiming *>(dev))->is_BunchLength_allowed(ty);}
};

class DriverVoltageAttrib: public Tango::Attr
{
public:
	DriverVoltageAttrib():Attr("DriverVoltage", Tango::DEV_DOUBLE, Tango::READ) {};
	~DriverVoltageAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Guntiming *>(dev))->read_DriverVoltage(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Guntiming *>(dev))->is_DriverVoltage_allowed(ty);}
};

class DriverCurAttrib: public Tango::Attr
{
public:
	DriverCurAttrib():Attr("DriverCur", Tango::DEV_DOUBLE, Tango::READ) {};
	~DriverCurAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Guntiming *>(dev))->read_DriverCur(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Guntiming *>(dev))->is_DriverCur_allowed(ty);}
};

class GridVoltageAttrib: public Tango::Attr
{
public:
	GridVoltageAttrib():Attr("GridVoltage", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~GridVoltageAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Guntiming *>(dev))->read_GridVoltage(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Guntiming *>(dev))->write_GridVoltage(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Guntiming *>(dev))->is_GridVoltage_allowed(ty);}
};

class ModestringAttrib: public Tango::Attr
{
public:
	ModestringAttrib():Attr("Modestring", Tango::DEV_STRING, Tango::READ) {};
	~ModestringAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Guntiming *>(dev))->read_Modestring(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Guntiming *>(dev))->is_Modestring_allowed(ty);}
};

class ModeAttrib: public Tango::Attr
{
public:
	ModeAttrib():Attr("Mode", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~ModeAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Guntiming *>(dev))->read_Mode(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Guntiming *>(dev))->write_Mode(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Guntiming *>(dev))->is_Mode_allowed(ty);}
};

class FilCurAttrib: public Tango::Attr
{
public:
	FilCurAttrib():Attr("FilCur", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~FilCurAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Guntiming *>(dev))->read_FilCur(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Guntiming *>(dev))->write_FilCur(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Guntiming *>(dev))->is_FilCur_allowed(ty);}
};

//=========================================
//	Define classes for commands
//=========================================
class RestartClass : public Tango::Command
{
public:
	RestartClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	RestartClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~RestartClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Guntiming *>(dev))->is_Restart_allowed(any);}
};



class StinitClass : public Tango::Command
{
public:
	StinitClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	StinitClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~StinitClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Guntiming *>(dev))->is_Stinit_allowed(any);}
};


class RawClass : public Tango::Command
{
public:
	RawClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	RawClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~RawClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Guntiming *>(dev))->is_Raw_allowed(any);}
};



//
// The GuntimingClass singleton definition
//

class GuntimingClass : public Tango::DeviceClass
{
public:
//	properties member data

//	add your own data members here
//------------------------------------

public:
	Tango::DbData	cl_prop;
	Tango::DbData	cl_def_prop;
	Tango::DbData	dev_def_prop;

//	Method prototypes
	static GuntimingClass *init(const char *);
	static GuntimingClass *instance();
	~GuntimingClass();
	Tango::DbDatum	get_class_property(string &);
	Tango::DbDatum	get_default_device_property(string &);
	Tango::DbDatum	get_default_class_property(string &);
	
protected:
	GuntimingClass(string &);
	static GuntimingClass *_instance;
	void command_factory();
	void get_class_property();
	void attribute_factory(vector<Tango::Attr *> &);
	void write_class_property();
	void set_default_property();

private:
	void device_factory(const Tango::DevVarStringArray *);
};


}	//	namespace Guntiming_ns

#endif // _GUNTIMINGCLASS_H
